org.fife.ui.rsyntaxtextarea.modes

## Class CTokenMaker

- java.lang.Object
- - org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker
  - - org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker
    - - org.fife.ui.rsyntaxtextarea.modes.CTokenMaker

All Implemented Interfaces:
  TokenMaker

    public class CTokenMaker
    extends AbstractJFlexCTokenMaker

Scanner for the C programming language. This implementation was created using JFlex 1.4.1; however, the generated file was modified for performance. Memory allocation needs to be almost completely removed to be competitive with the handwritten lexers (subclasses of `AbstractTokenMaker`, so this class has been modified so that Strings are never allocated (via yytext()), and the scanner never has to worry about refilling its buffer (needlessly copying chars around). We can achieve this because RText always scans exactly 1 line of tokens at a time, and hands the scanner this line as an array of characters (a Segment really). Since tokens contain pointers to char arrays instead of Strings holding their contents, there is no need for allocating new memory for Strings.

The actual algorithm generated for scanning has, of course, not been modified.

If you wish to regenerate this file yourself, keep in mind the following:

- The generated `CTokenMaker.java` file will contain two definitions of both `zzRefill` and `yyreset`. You should hand-delete the second of each definition (the ones generated by the lexer), as these generated methods modify the input buffer, which we'll never have to do.
- You should also change the declaration/definition of zzBuffer to NOT be initialized. This is a needless memory allocation for us since we will be pointing the array somewhere else anyway.
- You should NOT call `yylex()` on the generated scanner directly; rather, you should use `getTokenList` as you would with any other `TokenMaker` instance.

Version:
  0.5
Author:
  Robert Futrell

### Field Summary

Fields
`protected TokenImpl` `currentToken` Used in the creation of the linked list.
`static int` `EOL_COMMENT` lexical states
`protected TokenImpl` `firstToken` The first token in the returned linked list.
`static int` `MLC`
`protected TokenImpl` `previousToken` Used in the creation of the linked list.
`static int` `YYEOF` This character denotes the end of file
`static int` `YYINITIAL`

### Fields inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker

`INSERT_BREAK_ACTION`

### Fields inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker

`offsetShift, s, start`

### Constructor Summary

Constructors
Constructor and Description
`CTokenMaker()` Constructor.
`CTokenMaker(InputStream in)` Creates a new scanner.
`CTokenMaker(Reader in)` Creates a new scanner There is also a java.io.InputStream version of this constructor.

### Method Summary

Methods
`void` `addNullToken()` Adds a null token to the end of the current linked list of tokens.
`void` `addToken(char[] array, int start, int end, int tokenType, int startOffset)` Adds the token specified to the current linked list of tokens.
`void` `addToken(char[] array, int start, int end, int tokenType, int startOffset, boolean hyperlink)` Adds the token specified to the current linked list of tokens.
`void` `addToken(Segment segment, int start, int end, int tokenType, int startOffset)` Adds the token specified to the current linked list of tokens.
`protected OccurrenceMarker` `createOccurrenceMarker()` Returns the occurrence marker to use for this token maker.
`int` `getClosestStandardTokenTypeForInternalType(int type)` Returns the closest `"standard" token type` for a given "internal" token type (e.g. one whose value is `< 0`).
`int` `getLastTokenTypeOnLine(Segment text, int initialTokenType)` Returns the last token on this line's type if the token is "unfinished", or `TokenTypes.NULL` if it was finished.
`String[]` `getLineCommentStartAndEnd()` Returns the text to place at the beginning and end of a line to "comment" it in a this programming language.
`OccurrenceMarker` `getOccurrenceMarker()` Returns the object in charge of marking all occurrences of the token at the current caret position, if it is a relevant token.
`Token` `getTokenList(Segment text, int initialTokenType, int startOffset)` Returns the first token in the linked list of tokens generated from `text`.
`boolean` `isMarkupLanguage()` The default implementation returns `false` always.
`protected void` `resetTokenList()` Deletes the linked list of tokens so we can begin anew.
`void` `setLanguageIndex(int languageIndex)` Sets the language index to assign to tokens moving forward.
`void` `yybegin(int newState)` Enters a new lexical state
`char` `yycharat(int pos)` Returns the character at position `pos` from the matched text.
`void` `yyclose()` Closes the input stream.
`int` `yylength()` Returns the length of the matched text region.
`Token` `yylex()` Resumes scanning until the next regular expression is matched, the end of input is encountered or an I/O-Error occurs.
`void` `yypushback(int number)` Pushes the specified amount of characters back into the input stream.
`void` `yyreset(Reader reader)` Resets the scanner to read from a new input stream.
`int` `yystate()` Returns the current lexical state.
`String` `yytext()` Returns the text matched by the current regular expression.

### Methods inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker

`getCurlyBracesDenoteCodeBlocks, getInsertBreakAction, getMarkOccurrencesOfTokenType, getShouldIndentNextLineAfter`

### Methods inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker

`yybegin`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### YYEOF

    public static final int YYEOF

This character denotes the end of file

See Also:
  Constant Field Values

#### EOL_COMMENT

    public static final int EOL_COMMENT

lexical states

See Also:
  Constant Field Values

#### YYINITIAL

    public static final int YYINITIAL

See Also:
  Constant Field Values

#### MLC

    public static final int MLC

See Also:
  Constant Field Values

#### firstToken

    protected TokenImpl firstToken

The first token in the returned linked list.

#### currentToken

    protected TokenImpl currentToken

Used in the creation of the linked list.

#### previousToken

    protected TokenImpl previousToken

Used in the creation of the linked list.

### Constructor Detail

#### CTokenMaker

    public CTokenMaker()

Constructor. This must be here because JFlex does not generate a no-parameter constructor.

#### CTokenMaker

    public CTokenMaker(Reader in)

Creates a new scanner There is also a java.io.InputStream version of this constructor.

Parameters:
  `in` - the java.io.Reader to read input from.

#### CTokenMaker

    public CTokenMaker(InputStream in)

Creates a new scanner. There is also java.io.Reader version of this constructor.

Parameters:
  `in` - the java.io.Inputstream to read input from.

### Method Detail

#### addToken

    public void addToken(char[] array,
                int start,
                int end,
                int tokenType,
                int startOffset)

Adds the token specified to the current linked list of tokens.

Specified by:
  `addToken` in interface `TokenMaker`
Parameters:
  `array` - The character array.
  `start` - The starting offset in the array.
  `end` - The ending offset in the array.
  `tokenType` - The token's type.
  `startOffset` - The offset in the document at which this token occurs.

#### getLineCommentStartAndEnd

    public String[] getLineCommentStartAndEnd()

Returns the text to place at the beginning and end of a line to "comment" it in a this programming language.

Specified by:
  `getLineCommentStartAndEnd` in interface `TokenMaker`
Returns:
  The start and end strings to add to a line to "comment" it out.

#### getTokenList

    public Token getTokenList(Segment text,
                     int initialTokenType,
                     int startOffset)

Returns the first token in the linked list of tokens generated from `text`. This method must be implemented by subclasses so they can correctly implement syntax highlighting.

Parameters:
  `text` - The text from which to get tokens.
  `initialTokenType` - The token type we should start with.
  `startOffset` - The offset into the document at which `text` starts.
Returns:
  The first `Token` in a linked list representing the syntax highlighted text.

#### yyreset

    public final void yyreset(Reader reader)

Resets the scanner to read from a new input stream. Does not close the old reader. All internal variables are reset, the old input stream cannot be reused (internal buffer is discarded and lost). Lexical state is set to `YY_INITIAL`.

Parameters:
  `reader` - the new input stream

#### yyclose

    public final void yyclose()
                       throws IOException

Closes the input stream.

Throws:
  `IOException`

#### yystate

    public final int yystate()

Returns the current lexical state.

#### yybegin

    public final void yybegin(int newState)

Enters a new lexical state

Specified by:
  `yybegin` in class `AbstractJFlexTokenMaker`
Parameters:
  `newState` - the new lexical state

#### yytext

    public final String yytext()

Returns the text matched by the current regular expression.

#### yycharat

    public final char yycharat(int pos)

Returns the character at position `pos` from the matched text. It is equivalent to yytext().charAt(pos), but faster

Parameters:
  `pos` - the position of the character to fetch. A value from 0 to yylength()-1.
Returns:
  the character at position pos

#### yylength

    public final int yylength()

Returns the length of the matched text region.

#### yypushback

    public void yypushback(int number)

Pushes the specified amount of characters back into the input stream. They will be read again by then next call of the scanning method

Parameters:
  `number` - the number of characters to be read again. This number must not be greater than yylength()!

#### yylex

    public Token yylex()
                throws IOException

Resumes scanning until the next regular expression is matched, the end of input is encountered or an I/O-Error occurs.

Returns:
  the next token
Throws:
  `IOException` - if any I/O-Error occurs

#### addNullToken

    public void addNullToken()

Adds a null token to the end of the current linked list of tokens. This should be put at the end of the linked list whenever the last token on the current line is NOT a multi-line token.

Specified by:
  `addNullToken` in interface `TokenMaker`

#### addToken

    public void addToken(Segment segment,
                int start,
                int end,
                int tokenType,
                int startOffset)

Adds the token specified to the current linked list of tokens.

Parameters:
  `segment` - `Segment` to get text from.
  `start` - Start offset in `segment` of token.
  `end` - End offset in `segment` of token.
  `tokenType` - The token's type.
  `startOffset` - The offset in the document at which this token occurs.

#### addToken

    public void addToken(char[] array,
                int start,
                int end,
                int tokenType,
                int startOffset,
                boolean hyperlink)

Adds the token specified to the current linked list of tokens.

Parameters:
  `array` - The character array.
  `start` - The starting offset in the array.
  `end` - The ending offset in the array.
  `tokenType` - The token's type.
  `startOffset` - The offset in the document at which this token occurs.
  `hyperlink` - Whether this token is a hyperlink.

#### createOccurrenceMarker

    protected OccurrenceMarker createOccurrenceMarker()

Returns the occurrence marker to use for this token maker. Subclasses can override to use different implementations.

Returns:
  The occurrence marker to use.

#### getClosestStandardTokenTypeForInternalType

    public int getClosestStandardTokenTypeForInternalType(int type)

Returns the closest `"standard" token type` for a given "internal" token type (e.g. one whose value is `< 0`).

The default implementation returns `type` always, which denotes that a mapping from internal token types to standard token types is not defined; subclasses can override.

Specified by:
  `getClosestStandardTokenTypeForInternalType` in interface `TokenMaker`
Parameters:
  `type` - The token type.
Returns:
  The closest "standard" token type.

#### getLastTokenTypeOnLine

    public int getLastTokenTypeOnLine(Segment text,
                             int initialTokenType)

Returns the last token on this line's type if the token is "unfinished", or `TokenTypes.NULL` if it was finished. For example, if C-style syntax highlighting is being implemented, and `text` contained a line of code that contained the beginning of a comment but no end-comment marker ("*\/"), then this method would return `TokenTypes.COMMENT_MULTILINE` for that line. This is useful for doing syntax highlighting.

Specified by:
  `getLastTokenTypeOnLine` in interface `TokenMaker`
Parameters:
  `text` - The line of tokens to examine.
  `initialTokenType` - The token type to start with (i.e., the value of `getLastTokenTypeOnLine` for the line before `text`).
Returns:
  The last token on this line's type, or `TokenTypes.NULL` if the line was completed.

#### getOccurrenceMarker

    public OccurrenceMarker getOccurrenceMarker()

Returns the object in charge of marking all occurrences of the token at the current caret position, if it is a relevant token. If `null` is returned, a default `OccurrenceMarker` is used.

Specified by:
  `getOccurrenceMarker` in interface `TokenMaker`
Returns:
  The occurrence marker for this language, or `null` for none.

#### isMarkupLanguage

    public boolean isMarkupLanguage()

The default implementation returns `false` always. Subclasses that are highlighting a markup language should override this method to return `true`.

Specified by:
  `isMarkupLanguage` in interface `TokenMaker`
Returns:
  `false` always.

#### resetTokenList

    protected void resetTokenList()

Deletes the linked list of tokens so we can begin anew. This should never have to be called by the programmer, as it is automatically called whenever the user calls `getLastTokenTypeOnLine(Segment, int)` or `TokenMaker.getTokenList(Segment, int, int)`.

#### setLanguageIndex

    public void setLanguageIndex(int languageIndex)

Sets the language index to assign to tokens moving forward. This property is used to designate tokens as being in "secondary" languages (such as CSS or JavaScript in HTML).

Parameters:
  `languageIndex` - The new language index. A value of `0` denotes the "main" language, any positive value denotes a specific secondary language. Negative values will be treated as `0`.